#ifndef __AY_H_INCLUDED
#define __AY_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _TYPE_BYTE_WORD
#define _TYPE_BYTE_WORD
typedef unsigned short int Word;
typedef unsigned char      Byte;
#endif

#pragma pack(1)
typedef union
{
    Byte Regs[14];
    struct {
                Word toneA;
                Word toneB;
                Word toneC;
                Byte noise;
                Byte control;
                Byte volumeA;
                Byte volumeB;
                Byte volumeC;
                Word env_freq;
                Byte env_style;
    }Values;
}AYREGS;
#pragma pack()

/*        VTX  */
typedef enum
{
        _MONO = 0,
        _ABC  = 1,
        _ACB  = 2,
        _BAC  = 3,
        _BCA  = 4,
        _CAB  = 5,
        _CBA  = 6,
}stereo_t;

typedef enum {
        _AY = 0,
        _YM = 255,
}chip_t;

//       
// 24575     SSRC   
#define MAX_AMP         24575

/*     
 true  , 0  .
    16  ,
  .
 : AY_SetSoundFormat(44100,2,16) 
       */
extern int AY_SetSoundFormat(int freq,int chans, int bpc);

/*  ,    .
  -1    */
extern void AY_SetChip(chip_t chip, int chipfreq, stereo_t stereo);

//      
//       [-100..100],  
//          
void AY_SetEQ(int Amp_A_l, int Amp_A_r, int Amp_B_l, int Amp_B_r, int Amp_C_l, int Amp_C_r);

/*     
   AY 16 */
extern void AY_SetAYTable(Word *tbl);

/*     
   YM 32  */
extern void AY_SetYMTable(Word *tbl);

/* c ,      
      
 ,      */
extern void AY_Start();

/*    */
extern void AY_SetRegs(char *regs);

/*  numcount   
      ,  AY_SetSoundFormat()
          */
extern Byte* AY_Synth(Byte *buf_pos, int numcount);

#ifdef __cplusplus
}
#endif

#endif //!__AY_H_INCLUDED
