#ifndef _VTXFILE_
#define _VTXFILE_

#include <stdio.h>


#ifndef _TYPE_BYTE_WORD
#define _TYPE_BYTE_WORD
typedef unsigned short int Word;
typedef unsigned char      Byte;
#endif


//   NTString (.  VTX)
#define VTX_NTSTRING_MAX 255

//        
//    vtx .     
//      .
typedef struct
{
    char*	Chip;	/* char pointer to string "ay" or "ym" */
    Byte	Stereo; /* 0-ABC, 1-BCA... */
    Word	Loop;
    int		ChipFreq;
 /* AY chip freq */
    Byte	PlayerFreq;
    Word	Year;
	
    //    NTStrings 
    char	Title[VTX_NTSTRING_MAX];
    char	Author[VTX_NTSTRING_MAX];
    char	From[VTX_NTSTRING_MAX];
    char	Tracker[VTX_NTSTRING_MAX];
    char	Comment[VTX_NTSTRING_MAX];
	
    //   
    Byte   	*regdata;	// (NULL   )
    int		regdata_size;
    
    FILE	*fp;	//    .vtx
    int		pos;
	//      
} VTXFile;



//       VTX
//       
//    VthHeader.
//     true (1)
//    false (0)
int VTX_ReadHeader(VTXFile *vf, char *filename);

/*     .
	  ,    
	VTX_ReadHeader  . 
	 1  , 0    */
int VTX_ReadData(VTXFile *vf);

/*      
  1,    
 0, ,    */
int VTX_GetNextRegs(VTXFile *vf,char *regs);

/*      
	 VTXFile,     */
void VTX_Free(VTXFile *vf);

#endif
